<?php

namespace App\Services\Part;

use RuntimeException;
use App\Models\Part\SOFTWAREModel;
use App\Helpers\Part\SOFTWAREHelper;
use App\Forms\Part\SOFTWAREForm;
use App\Entities\Part\SOFTWAREEntity;
use App\Entities\Equipment\ServerPartEntity;

class SOFTWAREService extends PartType1Service
{
    protected string $formClass = SOFTWAREForm::class;
    protected string $helperClass = SOFTWAREHelper::class;

    public function __construct(SOFTWAREModel $model)
    {
        parent::__construct($model);
        $this->addClassPaths('SOFTWARE');
    }
    public function getEntityClass(): string
    {
        return SOFTWAREEntity::class;
    }
    //기본 기능부분
    protected function getEntity_process(mixed $entity): SOFTWAREEntity
    {
        return $entity;
    }
    //List 검색용
    //FormFilter 조건절 처리
    //검색어조건절처리
    //OrderBy 처리
    public function setOrderBy(mixed $field = null, mixed $value = null): void
    {
        $this->model->orderBy('title ASC');
        parent::setOrderBy($field, $value);
    }
    //서버파트관련 작업
    //파트정보가져오기
    public function getPartEntityByServerPart(ServerPartEntity $serverPartEntity): SOFTWAREEntity
    {
        //IP정보에서 해당하는 IP가 있으면 가져와서 사용중인지 체크 후 수정
        $entity = $this->getEntity($serverPartEntity->getPartUid());
        if (!$entity instanceof SOFTWAREEntity) {
            throw new RuntimeException(static::class . '->' . __FUNCTION__ . "에서 {$serverPartEntity->getPartUid()}에 해당하는 SOFTWAREEntity정보를 찾을수없습니다.");
        }
        return $entity;
    }
}
